       PROGRAM STRONG
       REAL*8 K(12), T(12), APROB, AMEAN(12)
       INTEGER A(13,13),L(12), SPECIES(13)
	INTEGER EXTRACT,ITEST
C... A IS THE BINARY MATRIX, L IS THE NO. TRANSITIVE PATHS OF EACH LENGTH
C... SPECIES IS THE SPECIES LIST USED TO EXTRACT SPECIES FROM A.
	CHARACTER*64 FNAME
	WRITE(*,111)
111	FORMAT(1X,'This program determines the number of strongly'/
     *' transitive paths of varying lengths in a binary competition'/
     *' matrix, and calculates the probability of such paths occuring'/
     *' under the null hypothesis, using Monte Carlo probabilities'//)
	WRITE(*,'(A\)')' NAME OF FILE TO STORE RESULTS?'
C.. FNAME IS THE NAME OF THE OUTPUT FILE
	READ(*,'(A)')FNAME
	OPEN(7,FILE=FNAME,ACCESS='SEQUENTIAL', STATUS='NEW')
       WRITE(*,110)
110    FORMAT(1X,'NUMBER OF SPECIES IN THE BINARY MATRIX?')
       READ(*,115)ISIZE
115    FORMAT(I2)
       DO 10 I=1,ISIZE
        WRITE(*,100)I
100     FORMAT(1X,'GIVE ROW ',I2,' OF THE BINARY MATRIX')
        READ(*,105)(A(I,J),J=1,ISIZE)
C.. NEXT LINE INITIALIZES OBSERVED NUMBERS OF PATHS OF VARIOUS
C.. LENGTHS -L(I)- TO ZERO
       IF(ISIZE.LT.13)L(I)=0 
10     IF(ISIZE.LT.13)SPECIES(I)=0
105    FORMAT(13(I1,1X))
       ICOUNT=0
       WRITE(7,145)
145    FORMAT(1X,'Output of program STRONG'/
     *' STRONGLY TRANSITIVE PATHS WITHIN THE MATRIX')
	DO 1000 I1=1,(ISIZE-1)
	 SPECIES(1)=I1
	DO 1001 I2=(I1+1),ISIZE
	  SPECIES(2)=I2
	  ITEST=EXTRACT(A,ISIZE, SPECIES, 2,1)
	  IF(ITEST.NE.1) GO TO 1001
	   L(1)=L(1)+1
	 DO 1002 I3=(I2+1),ISIZE
	   SPECIES(3)=I3
	   ITEST=EXTRACT(A,ISIZE, SPECIES,3,1)
	   IF (ITEST.NE.1) GO TO 1002
	    L(2)=L(2)+1
	 DO 1003 I4=(I3+1),ISIZE
	  SPECIES(4)=I4
	  ITEST=EXTRACT(A,ISIZE, SPECIES, 4,1)
	  IF(ITEST.NE.1) GO TO 1003
	   L(3)=L(3)+1
	  DO 1004 I5=(I4+1),ISIZE
	   SPECIES(5)=I5
	   ITEST=EXTRACT(A,ISIZE, SPECIES,5,1)
	   IF (ITEST.NE.1) GO TO 1004
	   L(4)=L(4)+1
	 DO 1005 I6=(I5+1),ISIZE
	  SPECIES(6)=I6
	  ITEST=EXTRACT(A,ISIZE, SPECIES, 6,1)
	  IF(ITEST.NE.1) GO TO 1005
	   L(5)=L(5)+1
	  DO 1006 I7=(I6+1),ISIZE
	   SPECIES(7)=I7
	   ITEST=EXTRACT(A,ISIZE, SPECIES,7,1)
	   IF (ITEST.NE.1) GO TO 1006
	   L(6)=L(6)+1
	 DO 1007 I8=(I7+1),ISIZE
	  SPECIES(8)=I8
	  ITEST=EXTRACT(A,ISIZE, SPECIES, 8,1)
	  IF(ITEST.NE.1) GO TO 1007
	   L(7)=L(7)+1
	  DO 1008 I9=(I8+1),ISIZE
	   SPECIES(9)=I9
	   ITEST=EXTRACT(A,ISIZE, SPECIES,9,1)
	   IF (ITEST.NE.1) GO TO 1008
	   L(8)=L(8)+1
	 DO 1009 I10=(I9+1),ISIZE
	  SPECIES(10)=I10
	  ITEST=EXTRACT(A,ISIZE, SPECIES, 10,1)
	  IF(ITEST.NE.1) GO TO 1009
	   L(9)=L(9)+1
	  DO 1010 I11=(I10+1),ISIZE
	   SPECIES(11)=I11
	   ITEST=EXTRACT(A,ISIZE, SPECIES,11,1)
	   IF (ITEST.NE.1) GO TO 1010
	   L(10)=L(10)+1
	 DO 1011 I12=(I11+1),ISIZE
	  SPECIES(12)=I12
	  ITEST=EXTRACT(A,ISIZE, SPECIES, 12,1)
	  IF(ITEST.NE.1) GO TO 1011
	   L(11)=L(11)+1
	  DO 1012 I13=(I12+1),ISIZE
	   SPECIES(13)=I13
	   ITEST=EXTRACT(A,ISIZE, SPECIES,13,1)
	   IF (ITEST.NE.1) GO TO 1012
	   L(12)=L(12)+1
1012	CONTINUE
1011	CONTINUE
1010	CONTINUE
1009	CONTINUE
1008	CONTINUE
1007	CONTINUE
1006	CONTINUE
1005	CONTINUE
1004	CONTINUE
1003	CONTINUE
1002	CONTINUE
1001	CONTINUE
1000   	CONTINUE
      CALL THETA(L,A,ISIZE,T,APROB)
C.. L IS THE INPUT VECTOR OF OBSERVED PATH LENGTHS, A IS THE BINARY
C.. MATRIX, ISIZE IS THE TOTAL NUMBER OF SPECIES, 
C...T IS THE OUTPUT VECTOR OF TOTAL POSSIBLE NUMBERS OF PATHS.
C.. AND AMEAN IS THE OUTPUT VECTOR OF EXPECTED # PATHS OF EACH LENGTH.
500   WRITE(7,135)
135   FORMAT(1X,'---------------------'//, '(1) PATH LENGTH - L '//
     *' (2) TOTAL NUMBER OF PATHS POSSIBLE OF THAT LENGTH - T '//
     *' (3) EXPECTED NUMBER OF STRONGLY TRANSITIVE PATHS - MEAN'//	
     *' (4) OBSERVED NUMBER OF STRONGLY TRANSITIVE PATHS - M'//
     *' (5) PROBABILITY OF OBSERVING AT LEAST THAT NUMBER'/
     *'     OF STRONGLY TRANSITIVE PATHS - P(=>M)'///
     *' L       T            MEAN     M      P(=>M)')
	CALL SRANDOM(ISIZE,L,K,APROB,AMEAN)
      DO 20 I=1,(ISIZE-1)	
20    WRITE(7,140)I, T(I), AMEAN(I), L(I), K(I)
140   FORMAT(1X,I3,1X,F8.0,1X,F12.6,1X,I5,1X,F20.17)
      STOP
      END 
      SUBROUTINE THETA(L,A,ISIZE,T,P)
      REAL*8 ALINKS, SUC,P,Q,T(12),B,RFACT
      INTEGER A(13,13),L(12),NLINKS, I2(12)
C.. N IS THE NUMBER OF OFF-DIAGONAL ELEMENTS IN MATRIX
      N=ISIZE*(ISIZE-1)
      B=RFACT(ISIZE)
      P=0
      DO 10 I=1,13
      DO 10 J=1,13
10    P=P+A(I,J)
      P=P/N
	Q=1-P
C.. P IS THETA IN THE PAPER
C.. I.E. THE PROPORTION OF 1'S IN THE BINARY MATRIX
      DO 20 I=1,(ISIZE-1)
C .. THIS IS ISIZE!/((PATH+1)!*(ISIZE-PATH-1)!)
C.. I.E. THE TOTAL NUMBER OF POSSIBLE PATHS OF LENGTH (ISIZE-1)
        T(I)=B/(RFACT(I+1)*RFACT(ISIZE-I-1))
        I2(I)=IDINT(T(I))
C.. I2(I) IS THE INTEGER EQUIVALENT OF T(I)
20    CONTINUE
	WRITE(7,124)
124     FORMAT(1X,/'......................................'//
     *' (1) PATH LENGTH - L'/
     *' (2) PROB. OF FINDING A SINGLE TRANSITIVE PATH - THETA'/
     *' L                     THETA')
      DO 30 I=1,(ISIZE-1)
          KL=I+1
	  ALINKS=RFACT(KL)/(RFACT(2)*RFACT(KL-2))
	  NLINKS=IDINT(ALINKS)
          SUC=RFACT(KL)*(P**NLINKS)*(Q**NLINKS)
	WRITE(7,123)I,SUC
123	FORMAT(1X,I2,10X, F20.18)
30	CONTINUE
      RETURN
      END
       SUBROUTINE SRANDOM(ISIZE,M,K,APROB, AMEAN)
       REAL*8 K(13), T(12), AMEAN(12)
	REAL*8 RFACT, APROB
       INTEGER A(13,13),L(12), SPECIES(13), LMATRIX(12,1716)
	INTEGER M(12), TYPE, ITEST, ISIZE, EXTRACT
	TYPE=-1
C... A IS THE BINARY MATRIX, L IS THE NO. TRANSITIVE PATHS OF EACH LENGTH
C... SPECIES IS THE SPECIES LIST USED TO EXTRACT SPECIES FROM A.
	WRITE(*,768)
768	FORMAT(1X,'... CALCULATING THE MONTE CARLO PROBABILITIES ...'//
     *' YOU MUST SPECIFY THE NUMBER OF ITERATIONS THAT YOU WANT.'/
     *' A SMALL NUMBER (1000) WILL TAKE LESS TIME BUT WILL GIVE'/
     *' LESS PRECISE ESTIMATES OF THE PROBABILITIES.  A LARGE'/
     *' NUMBER (50000) MAY TAKE A LONG TIME TO COMPUTE.'//)
	WRITE(*,566)
566	FORMAT(1X,'NUMBER OF ITERATIONS?')
	READ(*,567)ITERATE
567	FORMAT(I6)
	IDUM=-1
	DO 34 I=1,(ISIZE-1)
	AMEAN(I)=0.0
 	DO 34 J=1,1716
34	LMATRIX(I,J)=0
	JTEST=0
C..  THIS IS THE BIG LOOP.............
	DO 100 I=1,ITERATE
	IPRINT=I/500
	IF(IPRINT.GT.JTEST)THEN
	  WRITE(*,123)I
123	  FORMAT(1X,'ITERATION ',I6)
	  JTEST=IPRINT
	ENDIF
	CALL MATRIX(A,IDUM,ISIZE,APROB)
	DO 101 IZERO=1,(ISIZE-1)
101	L(IZERO)=0
	DO 1000 I1=1,(ISIZE-1)
	 SPECIES(1)=I1
	DO 1001 I2=(I1+1),ISIZE
	  SPECIES(2)=I2
	  ITEST=EXTRACT(A,ISIZE,SPECIES,2,TYPE)
	  IF(ITEST.NE.1) GO TO 1001
	   L(1)=L(1)+1
	 DO 1002 I3=(I2+1),ISIZE
	   SPECIES(3)=I3
	   ITEST=EXTRACT(A,ISIZE, SPECIES,3, TYPE)
	   IF (ITEST.NE.1) GO TO 1002
	    L(2)=L(2)+1
	 DO 1003 I4=(I3+1),ISIZE
	  SPECIES(4)=I4
	  ITEST=EXTRACT(A,ISIZE, SPECIES, 4, TYPE)
	  IF(ITEST.NE.1) GO TO 1003
	   L(3)=L(3)+1
	  DO 1004 I5=(I4+1),ISIZE
	   SPECIES(5)=I5
	   ITEST=EXTRACT(A,ISIZE, SPECIES, 5, TYPE)
	   IF (ITEST.NE.1) GO TO 1004
	   L(4)=L(4)+1
	 DO 1005 I6=(I5+1),ISIZE
	  SPECIES(6)=I6
	  ITEST=EXTRACT(A,ISIZE, SPECIES, 6, TYPE)
	  IF(ITEST.NE.1) GO TO 1005
	   L(5)=L(5)+1
	  DO 1006 I7=(I6+1),ISIZE
	   SPECIES(7)=I7
	   ITEST=EXTRACT(A,ISIZE, SPECIES, 7, TYPE)
	   IF (ITEST.NE.1) GO TO 1006
	   L(6)=L(6)+1
	 DO 1007 I8=(I7+1),ISIZE
	  SPECIES(8)=I8
	  ITEST=EXTRACT(A,ISIZE, SPECIES, 8, TYPE)
	  IF(ITEST.NE.1) GO TO 1007
	   L(7)=L(7)+1
	  DO 1008 I9=(I8+1),ISIZE
	   SPECIES(9)=I9
	   ITEST=EXTRACT(A,ISIZE, SPECIES, 9, TYPE)
	   IF (ITEST.NE.1) GO TO 1008
	   L(8)=L(8)+1
	 DO 1009 I10=(I9+1),ISIZE
	  SPECIES(10)=I10
	  ITEST=EXTRACT(A,ISIZE, SPECIES, 10, TYPE)
	  IF(ITEST.NE.1) GO TO 1009
	   L(9)=L(9)+1
	  DO 1010 I11=(I10+1),ISIZE
	   SPECIES(11)=I11
	   ITEST=EXTRACT(A,ISIZE, SPECIES, 11, TYPE)
	   IF (ITEST.NE.1) GO TO 1010
	   L(10)=L(10)+1
	 DO 1011 I12=(I11+1),ISIZE
	  SPECIES(12)=I12
	  ITEST=EXTRACT(A,ISIZE, SPECIES, 12, TYPE)
	  IF(ITEST.NE.1) GO TO 1011
	   L(11)=L(11)+1
	  DO 1012 I13=(I12+1),ISIZE
	   SPECIES(13)=I13
	   ITEST=EXTRACT(A,ISIZE, SPECIES, 13, TYPE)
	   IF (ITEST.NE.1) GO TO 1012
	   L(12)=L(12)+1
1012	CONTINUE
1011	CONTINUE
1010	CONTINUE
1009	CONTINUE
1008	CONTINUE
1007	CONTINUE
1006	CONTINUE
1005	CONTINUE
1004	CONTINUE
1003	CONTINUE
1002	CONTINUE
1001	CONTINUE
1000   	CONTINUE
	DO 77 IL=1,(ISIZE-1)
	IAA=IL+1
	IBB=ISIZE-IL-1
	TOT=RFACT(ISIZE)/(RFACT(IAA)*RFACT(IBB))
	IT=INT(TOT)
	DO 72 IN=1,IT
	 IF(L(IL).EQ.IN)LMATRIX(IL,IN)=LMATRIX(IL,IN)+1
72	CONTINUE
77	CONTINUE
100	CONTINUE
	DO 86 IL=1,(ISIZE-1)
	ISUM=0
	IAA=IL+1
	IBB=ISIZE-IL-1
	TOT=RFACT(ISIZE)/(RFACT(IAA)*RFACT(IBB))
	IT=INT(TOT)
	DO 941 J=1,IT
941	ISUM=ISUM+LMATRIX(IL,J)
	K(IL)=FLOAT(ITERATE-ISUM)/FLOAT(ITERATE)
	DO 1871 J=1,IT
	AMEAN(IL)=FLOAT(J)*(FLOAT(LMATRIX(IL,J))/FLOAT(ITERATE))+
     *  AMEAN(IL)
1871	CONTINUE
	IF(M(IL).EQ.0)THEN
	  K(IL)=0
	  GO TO 86
	ENDIF
	IF(M(IL).EQ.1)GO TO 86
	DO 87 IN=1,(M(IL)-1)
	K(IL)=(FLOAT(LMATRIX(IL,IN))/FLOAT(ITERATE)) + K(IL)
87	CONTINUE
86	CONTINUE
	DO 57 I=1,(ISIZE-1)
	K(I)=1-K(I)
57	CONTINUE
	RETURN
	END
      REAL*8 FUNCTION RFACT(I)
C.. THIS FUNCTION RETURNS THE FACTORIAL OF I
      INTEGER I
      RFACT=1
      IF(I.LE.1)RETURN
      DO 10 J=1,I
      K=(I+1)-J
      IF(RFACT.GT.(1.67D+307))THEN
       WRITE(*,100)
100   FORMAT(1X,'WARNING... FACTORIAL GETTING TOO BIG...')
      RFACT=-1
      RETURN
      ENDIF
10    RFACT=RFACT*K
      RETURN
      END 
	SUBROUTINE MATRIX(A,IDUM,ISIZE,APROB)
	REAL*8 APROB
	INTEGER A(13,13)
	DO 15 I=1,ISIZE
	DO 15 J=1,ISIZE
	X=RAN1(IDUM)
	A(I,J)=0
	IF(X.LE.APROB)THEN
	A(I,J)=1
	ENDIF
15	CONTINUE
	DO 10 I=1,ISIZE
10	A(I,I)=0
	RETURN
	END
      FUNCTION RAN1(IDUM)
      DIMENSION R(97)
      PARAMETER (M1=259200,IA1=7141,IC1=54773,RM1=3.8580247E-6)
      PARAMETER (M2=134456,IA2=8121,IC2=28411,RM2=7.4373773E-6)
      PARAMETER (M3=243000,IA3=4561,IC3=51349)
      DATA IFF /0/
      IF (IDUM.LT.0.OR.IFF.EQ.0) THEN
        IFF=1
        IX1=MOD(IC1-IDUM,M1)
        IX1=MOD(IA1*IX1+IC1,M1)
        IX2=MOD(IX1,M2)
        IX1=MOD(IA1*IX1+IC1,M1)
        IX3=MOD(IX1,M3)
        DO 11 J=1,97
          IX1=MOD(IA1*IX1+IC1,M1)
          IX2=MOD(IA2*IX2+IC2,M2)
          R(J)=(FLOAT(IX1)+FLOAT(IX2)*RM2)*RM1
11      CONTINUE
        IDUM=1
      ENDIF
      IX1=MOD(IA1*IX1+IC1,M1)
      IX2=MOD(IA2*IX2+IC2,M2)
      IX3=MOD(IA3*IX3+IC3,M3)
      J=1+(97*IX3)/M3
      IF(J.GT.97.OR.J.LT.1)PAUSE
      RAN1=R(J)
      R(J)=(FLOAT(IX1)+FLOAT(IX2)*RM2)*RM1
      RETURN
      END 
      INTEGER FUNCTION EXTRACT(A,ISIZE,SPECIES, NSPECIES,TYPE)
C...  THIS FUNCTION EXTRACTS THE RELEVANT SPECIES FROM THE MAIN 
C...  BINARY MATRIX "A", PUTS THEM IN THE MATRIX "B", 
C...  REARRANGES THE SUBMATRIX "B" TO HAVE DECENDING
C...  DEGREES OF COMPETITIVE ABILITY (MATRIX "C"),
C...  AND TESTS WHETHER OR NOT THIS
C...  SUBMATRIX IS TRANSITIVE. IF YES, EXTRACT=1 ELSE 0.
C...  THE CORRECT ORDER OF SPECIES WITHIN THE PATH IS GIVEN IN
C...  MATRIX "NEWORDER"
	INTEGER A(13,13), B(13,13),C(13,13), SPECIES(13), NSPECIES
	INTEGER ROW(13), NEWORDER(13), IRANK(13), TYPE
C...	INITIALIZE MATRICES AND VECTORS
	DO 4 I1=1,13
4	NEWORDER(I1)=0	
	DO 5 I1=1,NSPECIES
	 ROW(I1)=0
	DO 5 I2=1,NSPECIES
5	  B(I1,I1)=0
C...    EXTRACT THE PROPER SPECIES FROM "A" AND CREATE "B"
	DO 10 I1=1,(NSPECIES-1)
	DO 10 I2=(I1+1), NSPECIES
	 IROW=SPECIES(I1)
	 ICOL=SPECIES(I2)
	 B(I1,I2)=A(IROW,ICOL)
10	 B(I2,I1)=A(ICOL,IROW)
C...    ADD UP THE NUMBER OF "1'S" IN EACH ROW OF "B"
	DO 20 I1=1,NSPECIES
	DO 20 I2=1,NSPECIES
20	ROW(I1)=ROW(I1)+B(I1,I2)
C...    SORT "B" FROM ROW WITH MOST 1'S TO LEAST, THEN 
C..     REARRANGES "B" AS "C".
	DO 40 J=1,NSPECIES
	LARGE=-1
	ICOUNT=0
	 DO 30 I1=1,NSPECIES
	  IF(ROW(I1).GT. LARGE) THEN
	  ICOUNT=I1
	  LARGE=ROW(I1)
	 ENDIF
30	CONTINUE
	NEWORDER(J)=SPECIES(ICOUNT)
	IRANK(J)=ICOUNT
40	ROW(ICOUNT)=-1
	DO 50 I=1,NSPECIES
	I1=IRANK(I)
	DO 50 J=1,NSPECIES
         J1=IRANK(J)
50	 C(I,J)=B(I1,J1)
	DO 60 I1=1,NSPECIES
	DO 61 I2=(I1+1),NSPECIES
	 IF(C(I1,I2).NE.1.OR.C(I2,I1).NE.0) THEN
	 EXTRACT=0
	 RETURN
	ENDIF
61	CONTINUE
60	CONTINUE
	EXTRACT=1
	IF(TYPE.EQ.-1)RETURN
	WRITE(7,100)(NEWORDER(I), I=1,NSPECIES)
100	FORMAT(1X, 13(I2,1X))
	RETURN
	END
